datablock ParticleData(deleteProjectileTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 600;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/star1";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "1 1 1 0.3";
	colors[1]	= "0 1 0 0.2";
	colors[2]	= "1 1 1 0.0";
	sizes[0]	= 0.15;
	sizes[1]	= 0.35;
	sizes[2]	= 0.05;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(deleteProjectileTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = deleteProjectileTrailParticle;

   useEmitterColors = true;
   uiName = "DeleteLauncherTrail";
};

datablock ProjectileData(deleteProjectile)
{
   projectileShapeName = "./deleteProjectile.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::deleteLauncher;
   radiusDamageType    = $DamageType::deleteLauncher;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = "";
   particleEmitter     = deleteProjectileTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 3.0;
   lightColor  = "0 1 0";

   uiName = "deleteProjectile";
};

//////////
// item //
//////////
datablock ItemData(deleteLauncherItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./deleteLauncher.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Delete Launcher";
	iconName = "./icon_dl";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = deleteLauncherImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(deleteLauncherImage)
{
   // Basic Item properties
   shapeFile = "./deleteLauncher.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   projectile = deleteProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = deleteLauncherItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.14;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= deleteLauncherFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= pillPopSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= deleteLauncherSmokeEmitter;
	stateEmitterTime[3]				= 0.25;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.25;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";

};

function deleteLauncherImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);
	Parent::onFire(%this,%obj,%slot);	
}

function deleteLauncherImage::onMount(%this, %player, %slot)
{
	parent::onMount(%this, %player, %slot);
	%player.hideNode("RHand");
}

function deleteLauncherImage::onUnMount(%this, %player, %slot)
{
	parent::onUnMount(%this, %player, %slot);
	%player.unHideNode("RHand");
}

function deleteProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
	parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
	if(!isObject(%col)) return;
	
	%group = %col.getGroup();
	%brickgroup = %group.getName();
	%id = %brickgroup.bl_id;
	%owner = findclientbyBL_ID(%id);
	if(%col.getClassName() $= "fxDTSBrick")
	{
		if(%brickgroup $= "Brickgroup_888888")
		{
			%obj.client.centerPrint("You cannot modify public bricks", 1);
			return;
		}

		if(%obj.client.getBL_IDTrustLevel(%owner.bl_id) > 1 || %obj.client.bl_id == %owner.bl_id)
		{
			%col.setColorFX(3);
			%col.disappear(-1);
			%col.schedule(300, delete);
		}
		else
		{
			%obj.client.centerPrint(%owner.getPlayerName() SPC "does not trust you enough to do that", 3);
		}
	}
	else
	{
		%obj.client.centerPrint("\c6This object is not a brick", 1);
	}
}

function serverCmddel(%client)
{
		%client.player.updateArm("deleteLauncherImage");
		%client.player.mountImage("deleteLauncherImage", 0);
}

package deleteLauncher
{
	function serverCmdUndoBrick(%client)
	{
		%undo = %client.undostack.val[%client.undoStack.head-1];
		if(getField(%undo, 1) $= "PLANT")
		{
			%brick = getField(%undo,0);

			if(!isObject(%brick)) return parent::serverCmdUndoBrick(%client);

			if(%brick.willCauseChainKill() == 1)
			{
				%brick.setColorFX(3);
				%brick.disappear(-1);
				%brick.schedule(300, delete);
				return;
			}
		}
		parent::serverCmdUndoBrick(%client);
	}
};
activatePackage(deleteLauncher);